using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Primitives;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private bool down = false;
        //private Point existing = Point.Empty;
        private int index = -1;
        private Point start = Point.Empty;
        private Point end = Point.Empty;
        List<Rectangle> rects = new List<Rectangle>();
        private double sensitivty = 10.0;

        private void Form1_Load(object sender, EventArgs e)
        {
             this.ultraChart1.Data.DataSource = Infragistics.UltraChart.Data.DemoTable.Table(0);
            this.ultraChart1.Data.DataBind();
            this.ultraChart1.MouseWheel += new MouseEventHandler(ultraChart1_MouseWheel);

        }

        void ultraChart1_MouseWheel(object sender, MouseEventArgs e)
        {
            int xextent = this.ultraChart1.Axis.X.Extent + this.ultraChart1.Axis.X.ScrollScale.Width;
            int yextent = this.ultraChart1.Axis.Y.Extent + this.ultraChart1.Axis.Y.ScrollScale.Width;
            int cwidth = this.ultraChart1.Width - xextent;
            int cheight = this.ultraChart1.Height - yextent;
            int relposX = e.X - xextent;
            if (relposX > 0 & e.Y < (cheight))
            {
                double locX = (((((double)relposX) / ((double)cwidth))) - .5) * this.ultraChart1.Axis.X.ScrollScale.Scale + this.ultraChart1.Axis.X.ScrollScale.Scroll;
                if (locX < 0 | locX > 1)
                {
                    this.ultraChart1.Axis.X.ScrollScale.Scroll = (double)(int)locX;
                }
                else
                {
                    this.ultraChart1.Axis.X.ScrollScale.Scroll = locX;
                }
                double locY = (((((double)e.Y) / ((double)cheight))) - .5) * this.ultraChart1.Axis.Y.ScrollScale.Scale + this.ultraChart1.Axis.Y.ScrollScale.Scroll;
                if (locY < 0 | locY > 1)
                {
                    this.ultraChart1.Axis.Y.ScrollScale.Scroll = 1.0 - (double)(int)locY;
                }
                else
                {
                    this.ultraChart1.Axis.Y.ScrollScale.Scroll = 1.0 - locY;
                }
                if (e.Delta > 0)
                {
                    if (this.ultraChart1.Axis.X.ScrollScale.Scale > .1)
                    {
                        this.ultraChart1.Axis.X.ScrollScale.Scale -= .1;
                    }
                    else
                    {
                        this.ultraChart1.Axis.X.ScrollScale.Scale = 0.05;
                    }
                    if (this.ultraChart1.Axis.Y.ScrollScale.Scale > .1)
                    {
                        this.ultraChart1.Axis.Y.ScrollScale.Scale -= .1;
                    }
                    else
                    {
                        this.ultraChart1.Axis.Y.ScrollScale.Scale = 0.05;
                    }
                }
                else
                {
                    if (this.ultraChart1.Axis.X.ScrollScale.Scale < 0.9)
                    {
                        this.ultraChart1.Axis.X.ScrollScale.Scale += .1;
                    }
                    else
                    {
                        this.ultraChart1.Axis.X.ScrollScale.Scale = 1;
                        this.ultraChart1.Axis.X.ScrollScale.Scroll = .5;
                    }
                    if (this.ultraChart1.Axis.Y.ScrollScale.Scale < .9)
                    {
                        this.ultraChart1.Axis.Y.ScrollScale.Scale += .1;
                    }
                    else
                    {
                        this.ultraChart1.Axis.Y.ScrollScale.Scale = 1;
                        this.ultraChart1.Axis.Y.ScrollScale.Scroll = .5;
                    }
                }
                if (this.ultraChart1.Axis.X.ScrollScale.Scale < 1)
                {
                    this.ultraChart1.Axis.X.ScrollScale.Visible = true;
                }
                else
                {
                    this.ultraChart1.Axis.X.ScrollScale.Visible = false;
                }
                if (this.ultraChart1.Axis.Y.ScrollScale.Scale < 1)
                {
                    this.ultraChart1.Axis.Y.ScrollScale.Visible = true;
                }
                else
                {
                    this.ultraChart1.Axis.Y.ScrollScale.Visible = false;
                }
            }
        }

         private double getDistance(Point a, Point b)
        {
            return Math.Sqrt(Math.Pow(b.Y - a.Y, 2) + Math.Pow(b.X - a.X, 2));
        }

        private void ultraChart1_MouseDown(object sender, MouseEventArgs e)
        {
             down = true;
            if (e.Button == MouseButtons.Left)
            {
                start = new Point(e.X, e.Y);
            }
            for (int x = 0; x < rects.Count; x++)
            {
                if (getDistance(rects[x].Location, new Point(e.X, e.Y)) < sensitivty)
                {
                    start = new Point(rects[x].Location.X + rects[x].Width, rects[x].Location.Y + rects[x].Height);
                    index = x;
                    break;
                }
                if (getDistance(new Point(rects[x].Location.X + rects[x].Width, rects[x].Location.Y + rects[x].Height), new Point(e.X, e.Y)) < sensitivty)
                {
                    start = new Point(rects[x].Location.X,rects[x].Location.Y);
                    index = x;
                    break;
                }

            }
        }

        private void ultraChart1_MouseUp(object sender, MouseEventArgs e)
        {
            if (down & index==-1)
            {
                down = !down;
                end = new Point(e.X, e.Y);
                Point topleft = Point.Empty;
                Point bottomright = Point.Empty;
                if (start.X < end.X)
                {
                    topleft.X = start.X;
                    bottomright.X = end.X;
                }
                else
                {
                   topleft.X = end.X;
                    bottomright.X = start.X;
                }
                if (start.Y < end.Y)
                {
                    topleft.Y = start.Y;
                    bottomright.Y = end.Y;
                }
                else
                {
                   topleft.Y = end.Y;
                    bottomright.Y = start.Y;
                }
                rects.Add(new Rectangle(topleft.X, topleft.Y, bottomright.X - topleft.X, bottomright.Y - topleft.Y));
                this.ultraChart1.InvalidateLayers();
            }
            else if(down)
            {
                down = !down;
                end = new Point(e.X, e.Y);
                Point topleft = Point.Empty;
                Point bottomright = Point.Empty;
                if (start.X < end.X)
                {
                    topleft.X = start.X;
                    bottomright.X = end.X;
                }
                else
                {
                    topleft.X = end.X;
                    bottomright.X = start.X;
                }
                if (start.Y < end.Y)
                {
                    topleft.Y = start.Y;
                    bottomright.Y = end.Y;
                }
                else
                {
                    topleft.Y = end.Y;
                    bottomright.Y = start.Y;
                }
                rects[index]=new Rectangle(topleft.X, topleft.Y, bottomright.X - topleft.X, bottomright.Y - topleft.Y);
                this.ultraChart1.InvalidateLayers();
                //existing = Point.Empty;
                index = -1;
            }

        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            if (rects != null)
            {
                foreach (Rectangle r in rects)
                {
                    Box b = new Box(r);
                    e.SceneGraph.Add(b);
                }
            }

        }
    }
}